local _G = getfenv(0)
local L = _G.YurrCombatLogOptionsLocale
local db
local core = YurrCombatLog
local module = core:NewModule("YurrCombatLogOptions")
local frames = {}
for i=1,7 do
	tinsert(frames, "ChatFrame"..i)
end
-- Ninjad from Chatter/Prat
local FORMATS = {
	[ADDON_DISABLED] = ADDON_DISABLED,
	["HH:MM:SS AM (12-hour)"] = "%I:%M:%S %p",
	["HH:MM:SS (12-hour)"] = "%I:%M:%S",
	["HH:MM:SS (24-hour)"] = "%X",
	["HH:MM (12-hour)"] = "%I:%M",
	["HH:MM (24-hour)"] = "%H:%M",
	["MM:SS"] = "%M:%S"
}
function module:Initialize()
	db = core.db[core.db:GetCurrentProfile()]
	if not IsAddOnLoaded("BetterBlizOptions") then
		InterfaceOptionsFrame:SetWidth(655)
		InterfaceOptionsFrame:SetPoint("CENTER", UIParent, "CENTER")
	end
end

local frame = CreateFrame("Frame", nil, InterfaceOptionsFramePanelContainer)
frame.name = "YurrCombatLog"
frame:Hide()
frame:SetScript("OnShow", function(frame)
	local title, subtitle = LibStub("tekKonfig-Heading").new(frame, "YurrCombatLog", L["WhatIsYurrCombatLog"])
	
	-- outputFrame
	local outputFrameDropdown, outputFrameDropdowntext, outputFrameDropdowncontainer = LibStub("tekKonfig-Dropdown").new(frame, L["outputFrame"], "TOPLEFT", subtitle, "BOTTOMLEFT", -2, -8)
	outputFrameDropdowntext:SetText(db.outputFrame)
	outputFrameDropdown.tiptext = L["Desc_outputFrame"]
	outputFrameDropdown:SetWidth(170)

	local function outputFrameOnClick(self)
		UIDropDownMenu_SetSelectedValue(outputFrameDropdown, self.value)
		outputFrameDropdowntext:SetText(self.value)
		db.outputFrame = self.value
		Blizzard_CombatLog_Refilter()
	end
	UIDropDownMenu_Initialize(outputFrameDropdown, function()
		local selected, info = UIDropDownMenu_GetSelectedValue(outputFrameDropdown) or db.outputFrame, UIDropDownMenu_CreateInfo()

		for k, v in pairs(frames) do
			info.text = v
			info.value = v
			info.func = outputFrameOnClick
			info.checked = (v) == selected
			UIDropDownMenu_AddButton(info)
		end
	end)
	
	-- timestamp
	local timestampDropdown, timestampDropdowntext, timestampDropdowncontainer = LibStub("tekKonfig-Dropdown").new(frame, L["timestamp"], "TOPLEFT", subtitle, "BOTTOMLEFT", 168, -8)
	timestampDropdown:SetWidth(215)

	local function timestampOnClick(self)
		UIDropDownMenu_SetSelectedValue(timestampDropdown, self.value)
		timestampDropdowntext:SetText(self.value)
		if self.value == ADDON_DISABLED then
			db.timestamp = false
			db.timestampFormat = FORMATS[self.value]
		else
			db.timestamp = true
			db.timestampFormat = FORMATS[self.value]
		end
		Blizzard_CombatLog_Refilter()
	end
	UIDropDownMenu_Initialize(timestampDropdown, function()
		local selected, info = UIDropDownMenu_GetSelectedValue(timestampDropdown) or db.timestampFormat, UIDropDownMenu_CreateInfo()

		for k, v in pairs(FORMATS) do
			info.text = k
			info.value = k
			info.func = timestampOnClick
			info.checked = (v) == selected
			if v == selected then
				timestampDropdowntext:SetText(k)
			end
			UIDropDownMenu_AddButton(info)
		end
	end)
	
	frame:SetScript("OnShow", nil)
end)

InterfaceOptions_AddCategory(frame)
LibStub("tekKonfig-AboutPanel").new("YurrCombatLog", "YurrCombatLog")
